import{s as ae,n as oe,o as ne}from"../chunks/scheduler.00bde567.js";import{S as ie,i as le,g as l,s as n,r as P,A as re,h as r,f as a,c as i,j as ee,u as _,x as v,k as te,y as se,a as o,v as k,d as x,t as S,w as C}from"../chunks/index.752e2ff6.js";import{C as ce}from"../chunks/CodeBlock.e62cd1dc.js";import{H as O}from"../chunks/Heading.476d3364.js";function pe(R){let s,H,T,A,c,L,p,X=`With PyTorch v1.12 release, developers and researchers can take advantage of Apple silicon GPUs for significantly faster model training.
This unlocks the ability to perform machine learning workflows like prototyping and fine-tuning locally, right on Mac.
Apple’s Metal Performance Shaders (MPS) as a backend for PyTorch enables this and can be used via the new <code>&quot;mps&quot;</code> device.
This will map computational graphs and primitives on the MPS Graph framework and tuned kernels provided by MPS.
For more information please refer official documents <a href="https://pytorch.org/blog/introducing-accelerated-pytorch-training-on-mac/" rel="nofollow">Introducing Accelerated PyTorch Training on Mac</a>
and <a href="https://pytorch.org/docs/stable/notes/mps.html" rel="nofollow">MPS BACKEND</a>.`,G,f,U,m,V=`<li>Enables users to train larger networks or batch sizes locally</li> <li>Reduces data retrieval latency and provides the GPU with direct access to the full memory store due to unified memory architecture.
Therefore, improving end-to-end performance.</li> <li>Reduces costs associated with cloud-based development or the need for additional local GPUs.</li>`,q,h,D=`<strong>Pre-requisites</strong>: To install torch with mps support,
please follow this nice medium article <a href="https://medium.com/towards-data-science/gpu-acceleration-comes-to-pytorch-on-m1-macs-195c399efcc1" rel="nofollow">GPU-Acceleration Comes to PyTorch on M1 Macs</a>.`,W,d,Z,u,J=`It is enabled by default on MacOs machines with MPS enabled Apple Silicon GPUs.
To disable it, pass <code>--cpu</code> flag to <code>accelerate launch</code> command or answer the corresponding question when answering the <code>accelerate config</code> questionnaire.`,j,g,N="You can directly run the following script to test it out on MPS enabled Apple Silicon machines:",B,w,E,y,I,b,K=`<li>We strongly recommend to install PyTorch &gt;= 1.13 (nightly version at the time of writing) on your MacOS machine.
It has major fixes related to model correctness and performance improvements for transformer based models.
Please refer to <a href="https://github.com/pytorch/pytorch/issues/82707" rel="nofollow">https://github.com/pytorch/pytorch/issues/82707</a> for more details.</li> <li>Distributed setups <code>gloo</code> and <code>nccl</code> are not working with <code>mps</code> device.
This means that currently only single GPU of <code>mps</code> device type can be used.</li>`,z,$,Q=`Finally, please, remember that, 🤗 <code>Accelerate</code> only integrates MPS backend, therefore if you
have any problems or questions with regards to MPS backend usage, please, file an issue with <a href="https://github.com/pytorch/pytorch/issues" rel="nofollow">PyTorch GitHub</a>.`,F,M,Y;return c=new O({props:{title:"Accelerated PyTorch Training on Mac",local:"accelerated-pytorch-training-on-mac",headingTag:"h1"}}),f=new O({props:{title:"Benefits of Training and Inference using Apple Silicon Chips",local:"benefits-of-training-and-inference-using-apple-silicon-chips",headingTag:"h3"}}),d=new O({props:{title:"How it works out of the box",local:"how-it-works-out-of-the-box",headingTag:"h2"}}),w=new ce({props:{code:"YWNjZWxlcmF0ZSUyMGxhdW5jaCUyMCUyRmV4YW1wbGVzJTJGY3ZfZXhhbXBsZS5weSUyMC0tZGF0YV9kaXIlMjBpbWFnZXM=",highlighted:"accelerate launch /examples/cv_example.py --data_dir images",wrap:!1}}),y=new O({props:{title:"A few caveats to be aware of",local:"a-few-caveats-to-be-aware-of",headingTag:"h2"}}),{c(){s=l("meta"),H=n(),T=l("p"),A=n(),P(c.$$.fragment),L=n(),p=l("p"),p.innerHTML=X,G=n(),P(f.$$.fragment),U=n(),m=l("ol"),m.innerHTML=V,q=n(),h=l("p"),h.innerHTML=D,W=n(),P(d.$$.fragment),Z=n(),u=l("p"),u.innerHTML=J,j=n(),g=l("p"),g.textContent=N,B=n(),P(w.$$.fragment),E=n(),P(y.$$.fragment),I=n(),b=l("ol"),b.innerHTML=K,z=n(),$=l("p"),$.innerHTML=Q,F=n(),M=l("p"),this.h()},l(e){const t=re("svelte-u9bgzb",document.head);s=r(t,"META",{name:!0,content:!0}),t.forEach(a),H=i(e),T=r(e,"P",{}),ee(T).forEach(a),A=i(e),_(c.$$.fragment,e),L=i(e),p=r(e,"P",{"data-svelte-h":!0}),v(p)!=="svelte-1mfz1q4"&&(p.innerHTML=X),G=i(e),_(f.$$.fragment,e),U=i(e),m=r(e,"OL",{"data-svelte-h":!0}),v(m)!=="svelte-oq3rck"&&(m.innerHTML=V),q=i(e),h=r(e,"P",{"data-svelte-h":!0}),v(h)!=="svelte-1kbpcbh"&&(h.innerHTML=D),W=i(e),_(d.$$.fragment,e),Z=i(e),u=r(e,"P",{"data-svelte-h":!0}),v(u)!=="svelte-1lubatz"&&(u.innerHTML=J),j=i(e),g=r(e,"P",{"data-svelte-h":!0}),v(g)!=="svelte-1k89y14"&&(g.textContent=N),B=i(e),_(w.$$.fragment,e),E=i(e),_(y.$$.fragment,e),I=i(e),b=r(e,"OL",{"data-svelte-h":!0}),v(b)!=="svelte-9odwh8"&&(b.innerHTML=K),z=i(e),$=r(e,"P",{"data-svelte-h":!0}),v($)!=="svelte-ggojqf"&&($.innerHTML=Q),F=i(e),M=r(e,"P",{}),ee(M).forEach(a),this.h()},h(){te(s,"name","hf:doc:metadata"),te(s,"content",fe)},m(e,t){se(document.head,s),o(e,H,t),o(e,T,t),o(e,A,t),k(c,e,t),o(e,L,t),o(e,p,t),o(e,G,t),k(f,e,t),o(e,U,t),o(e,m,t),o(e,q,t),o(e,h,t),o(e,W,t),k(d,e,t),o(e,Z,t),o(e,u,t),o(e,j,t),o(e,g,t),o(e,B,t),k(w,e,t),o(e,E,t),k(y,e,t),o(e,I,t),o(e,b,t),o(e,z,t),o(e,$,t),o(e,F,t),o(e,M,t),Y=!0},p:oe,i(e){Y||(x(c.$$.fragment,e),x(f.$$.fragment,e),x(d.$$.fragment,e),x(w.$$.fragment,e),x(y.$$.fragment,e),Y=!0)},o(e){S(c.$$.fragment,e),S(f.$$.fragment,e),S(d.$$.fragment,e),S(w.$$.fragment,e),S(y.$$.fragment,e),Y=!1},d(e){e&&(a(H),a(T),a(A),a(L),a(p),a(G),a(U),a(m),a(q),a(h),a(W),a(Z),a(u),a(j),a(g),a(B),a(E),a(I),a(b),a(z),a($),a(F),a(M)),a(s),C(c,e),C(f,e),C(d,e),C(w,e),C(y,e)}}}const fe='{"title":"Accelerated PyTorch Training on Mac","local":"accelerated-pytorch-training-on-mac","sections":[{"title":"Benefits of Training and Inference using Apple Silicon Chips","local":"benefits-of-training-and-inference-using-apple-silicon-chips","sections":[],"depth":3},{"title":"How it works out of the box","local":"how-it-works-out-of-the-box","sections":[],"depth":2},{"title":"A few caveats to be aware of","local":"a-few-caveats-to-be-aware-of","sections":[],"depth":2}],"depth":1}';function me(R){return ne(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class we extends ie{constructor(s){super(),le(this,s,me,pe,ae,{})}}export{we as component};
